use maud::{html, Markup};

/// Flash message template builder.
///
/// Render a flash elements based on the given flash name and message.
pub fn build_template(flash_name: &str, flash_msg: &str) -> Markup {
    let common_classes = "capsule center center-text flash-message font-normal ";

    let border_class = match flash_name {
        "success" => "border-success",
        "info" => "border-info",
        "warning" => "border-warning",
        "error" => "border-danger",
        _ => "",
    };

    html! {
        div class={ (common_classes) (border_class) } {
            (flash_msg)
        }
    }
}
