// methods for interacting with tilde sbot

use crate::error::TildeError;

use serde_json::Value;
use std::process::{Command, exit};

mod error;

pub struct TildeClient {
    name: String,
    port: String
}
pub fn init_sbot() {
    println!("++ init sbot!");
}

pub fn get_sbot_client() -> TildeClient {
    TildeClient {
        name: "name".to_string(),
        port: "8009".to_string()
    }
}


impl TildeClient {

    pub fn run_tilde_command(&self, command: &str) -> Result<String, TildeError> {
        let output = Command::new("out/release/tildefriends.standalone")
            .arg(command)
            .output().map_err(|e| TildeError {
                message: format!("Command execution failed: {}", e),
        })?;

        if !output.status.success() {
            return Err(TildeError { message: format!("Command failed with status: {}", output.status) })
        }

        let result = String::from_utf8_lossy(&output.stdout).to_string();
        println!("Command output: {}", result);
        Ok(result)
    }
    pub async fn latest_description(&self, key: &str) -> Result<String, TildeError> {
        todo!();
    }

    pub async fn whoami(&self) -> Result<String, TildeError> {
        self.run_tilde_command("get_identity")
    }

    pub async fn is_following(&self, from_id: &str, to_id: &str) -> Result<bool, TildeError> {
        todo!();
    }

    pub async fn create_block(&self, key: &str) -> Result<bool, TildeError> {
        todo!();
    }
    pub async fn get_blocks(&self, key: &str) -> Result<Vec<String>, TildeError> {
        todo!();
    }

    pub async fn get_follows(&self, key: &str) -> Result<Vec<String>, TildeError> {
        todo!();
    }

    pub async fn get_friends(&self, key: &str) -> Result<Vec<String>, TildeError> {
        todo!();
    }

    pub async fn publish(&self, post: Value) -> Result<Vec<String>, TildeError> {
        todo!();
    }
}
